﻿Public Class Form1
    Const StatusText As String = "状態"
    WithEvents B As WebBrowser
    Dim cnt As Integer
    Private Sub GoBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GoBack.Click
        CType(TabControl1.SelectedTab.Controls(0), WebBrowser).GoBack()
    End Sub

    ''' <summary>
    ''' Application.DoEventsへのショートカット
    ''' </summary>
    ''' <remarks></remarks>
    Sub D()
        Application.DoEvents()
    End Sub
    Private Sub AddTab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddTab.Click
        Dim Tab As TabPage = New TabPage("Google")
        D()
        B = New WebBrowser
        D()
        B.Dock = DockStyle.Fill
        D()
        TabControl1.TabPages.Add(Tab)
        D()
        Tab.Controls.Add(B)
        D()
        TabControl1.SelectedTab = Tab
        D()
        CType(TabControl1.SelectedTab.Controls(0), WebBrowser).Navigate("https://www.google.com/")
        D()
        cnt += 1
    End Sub
    Sub Koushinn()
        D()
        If B Is Nothing Then Exit Sub
        Try
            TabControl1.SelectedTab.Text = CType(TabControl1.SelectedTab.Controls(0), WebBrowser).DocumentTitle
            AdressText.Text = CType(TabControl1.SelectedTab.Controls(0), WebBrowser).Url.ToString
        Catch ex As Exception
            Exit Sub
        End Try
        GoBack.Visible = B.CanGoBack
        GoFowred.Visible = B.CanGoForward
    End Sub
    Private Sub GoHome_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GoHome.Click
        On Error Resume Next
        CType(TabControl1.SelectedTab.Controls(0), WebBrowser).Navigate("https://www.google.com/")
        Koushinn()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If TabControl1.TabPages.Count >= 2 Then
            Select Case MsgBox("タブが複数開いています。すべて閉じますか？", MsgBoxStyle.YesNoCancel)
                Case MsgBoxResult.Yes
                    Me.Dispose()
                    Exit Select
                Case MsgBoxResult.No
                    If MsgBox("選択されたタブを閉じます。", MsgBoxStyle.OkCancel) = MsgBoxResult.Cancel Then
                        e.Cancel = True
                        Exit Sub
                    End If
                    TabControl1.SelectedTab.Dispose()
                    e.Cancel = True
                Case MsgBoxResult.Cancel
                    e.Cancel = True
            End Select
        Else
            End
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        AddTab_Click(sender, e)
    End Sub

    Private Sub GoFowred_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles GoFowred.Click
        On Error Resume Next
        CType(TabControl1.SelectedTab.Controls(0), WebBrowser).GoForward()
        Koushinn()
    End Sub

    Private Sub Go_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Go.Click
        CType(TabControl1.SelectedTab.Controls(0), WebBrowser).Navigate(urlString:=AdressText.Text)
        Koushinn()
    End Sub

    Private Sub Refresh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Refresh.Click
        CType(TabControl1.SelectedTab.Controls(0), WebBrowser).Refresh()
        Koushinn()
    End Sub

    Private Sub StopA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StopA.Click
        CType(TabControl1.SelectedTab.Controls(0), WebBrowser).Stop()
        Koushinn()
    End Sub

    Private Sub TabClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TabClose.Click
        If TabControl1.SelectedTab Is Nothing Then Exit Sub
        TabControl1.SelectedTab.Dispose()
        If TabControl1.TabPages.Count <= 0 Then End
    End Sub

    Private Sub WebBrowser1_Navigating(ByVal sender As Object, ByVal e As System.Windows.Forms.WebBrowserNavigatingEventArgs) Handles WebBrowser1.Navigating
        Koushinn()
    End Sub

    Private Sub B_Navigated(ByVal sender As Object, ByVal e As System.Windows.Forms.WebBrowserNavigatedEventArgs) Handles B.Navigated
        Koushinn()
    End Sub

    Private Sub B_Navigating(ByVal sender As Object, ByVal e As System.Windows.Forms.WebBrowserNavigatingEventArgs) Handles B.Navigating
        Koushinn()
    End Sub

    Private Sub B_NewWindow(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles B.NewWindow
        e.Cancel = True
    End Sub

    Private Sub B_ProgressChanged(ByVal sender As Object, ByVal e As System.Windows.Forms.WebBrowserProgressChangedEventArgs) Handles B.ProgressChanged
        Koushinn()
    End Sub

    Private Sub TabControl1_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TabControl1.SelectedIndexChanged
        If TabControl1.SelectedTab Is Nothing Then Exit Sub
        B = CType(TabControl1.SelectedTab.Controls(0), WebBrowser)
        Application.DoEvents()
        Koushinn()
    End Sub

    Private Sub ApplicationExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ApplicationExit.Click
        Me.Close()
    End Sub

    Private Sub AddTabA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddTabA.Click
        AddTab_Click(sender, e)
    End Sub

    Private Sub TabCloseA_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TabCloseA.Click
        TabClose_Click(sender, e)
    End Sub

    Private Sub PagePropety_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PagePropety.Click
        B.ShowPropertiesDialog()
    End Sub

    Private Sub ToolStripButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton1.Click
        B.ShowPrintDialog()
    End Sub

    Private Sub ToolStripButton2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton2.Click
        B.ShowPrintPreviewDialog()
    End Sub

    Private Sub ToolStripButton3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolStripButton3.Click
        B.ShowPageSetupDialog()
    End Sub
End Class
